
-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqadminlog`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqadminlog` (
  `id` int(11) NOT NULL,
  `time` int(11) NOT NULL,
  `usr` int(11) NOT NULL,
  `text` text NOT NULL,
  `ip` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqadminlog`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcaptcha`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcaptcha` (
  `id` varchar(6) NOT NULL,
  `useragent` varchar(255) NOT NULL,
  `language` varchar(2) NOT NULL,
  `ip` varchar(64) NOT NULL,
  `captcha_time` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcaptcha`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcategories`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcategories` (
  `id` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `parent_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description` varchar(255) default NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcategories`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcategory_group`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcategory_group` (
  `category_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  PRIMARY KEY  (`category_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcategory_group`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcategory_user`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcategory_user` (
  `category_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY  (`category_id`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcategory_user`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcategoryrelations`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcategoryrelations` (
  `category_id` int(11) NOT NULL,
  `category_lang` varchar(5) NOT NULL default '',
  `record_id` int(11) NOT NULL,
  `record_lang` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`category_id`,`category_lang`,`record_id`,`record_lang`),
  KEY `idx_records` (`record_id`,`record_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcategoryrelations`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqchanges`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqchanges` (
  `id` int(11) NOT NULL,
  `beitrag` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `revision_id` int(11) NOT NULL default '0',
  `usr` int(11) NOT NULL,
  `datum` int(11) NOT NULL,
  `what` text,
  PRIMARY KEY  (`id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqchanges`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqcomments`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqcomments` (
  `id_comment` int(11) NOT NULL,
  `id` int(11) NOT NULL,
  `type` varchar(10) NOT NULL,
  `usr` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `comment` text NOT NULL,
  `datum` int(15) NOT NULL,
  `helped` text,
  PRIMARY KEY  (`id_comment`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqcomments`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqconfig`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqconfig` (
  `config_name` varchar(255) NOT NULL default '',
  `config_value` varchar(255) default NULL,
  PRIMARY KEY  (`config_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqdata`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqdata` (
  `id` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `solution_id` int(11) NOT NULL,
  `revision_id` int(11) NOT NULL default '0',
  `active` char(3) NOT NULL,
  `keywords` text,
  `thema` text NOT NULL,
  `content` longtext,
  `author` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `comment` enum('y','n') NOT NULL default 'y',
  `datum` varchar(15) NOT NULL,
  `links_state` varchar(7) default NULL,
  `links_check_date` int(11) NOT NULL default '0',
  `date_start` varchar(14) NOT NULL default '00000000000000',
  `date_end` varchar(14) NOT NULL default '99991231235959',
  PRIMARY KEY  (`id`,`lang`),
  FULLTEXT KEY `keywords` (`keywords`,`thema`,`content`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqdata`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqdata_group`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqdata_group` (
  `record_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  PRIMARY KEY  (`record_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqdata_group`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqdata_revisions`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqdata_revisions` (
  `id` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `solution_id` int(11) NOT NULL,
  `revision_id` int(11) NOT NULL default '0',
  `active` char(3) NOT NULL,
  `keywords` text,
  `thema` text NOT NULL,
  `content` longtext,
  `author` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `comment` char(1) default 'y',
  `datum` varchar(15) NOT NULL,
  `links_state` varchar(7) default NULL,
  `links_check_date` int(11) NOT NULL default '0',
  `date_start` varchar(14) NOT NULL default '00000000000000',
  `date_end` varchar(14) NOT NULL default '99991231235959',
  PRIMARY KEY  (`id`,`lang`,`solution_id`,`revision_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqdata_revisions`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqdata_tags`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqdata_tags` (
  `record_id` int(11) NOT NULL,
  `tagging_id` int(11) NOT NULL,
  PRIMARY KEY  (`record_id`,`tagging_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqdata_tags`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqdata_user`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqdata_user` (
  `record_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY  (`record_id`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqdata_user`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqglossary`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqglossary` (
  `id` int(11) NOT NULL,
  `lang` varchar(2) NOT NULL,
  `item` varchar(255) NOT NULL,
  `definition` text NOT NULL,
  PRIMARY KEY  (`id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqglossary`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqgroup`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqgroup` (
  `group_id` int(11) NOT NULL,
  `name` varchar(25) default NULL,
  `description` text,
  `auto_join` int(1) unsigned default NULL,
  PRIMARY KEY  (`group_id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqgroup`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqgroup_right`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqgroup_right` (
  `group_id` int(11) NOT NULL,
  `right_id` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`group_id`,`right_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqgroup_right`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqlinkverifyrules`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqlinkverifyrules` (
  `id` int(11) NOT NULL default '0',
  `type` varchar(6) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `reason` varchar(255) NOT NULL default '',
  `enabled` enum('y','n') NOT NULL default 'y',
  `locked` enum('y','n') NOT NULL default 'n',
  `owner` varchar(255) NOT NULL default '',
  `dtInsertDate` varchar(15) NOT NULL default '',
  `dtUpdateDate` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqlinkverifyrules`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqnews`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqnews` (
  `id` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `header` varchar(255) NOT NULL,
  `artikel` text NOT NULL,
  `datum` varchar(14) NOT NULL,
  `author_name` varchar(255) default NULL,
  `author_email` varchar(255) default NULL,
  `active` char(1) default 'y',
  `comment` char(1) default 'n',
  `date_start` varchar(14) NOT NULL default '00000000000000',
  `date_end` varchar(14) NOT NULL default '99991231235959',
  `link` varchar(255) default NULL,
  `linktitel` varchar(255) default NULL,
  `target` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqnews`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqquestions`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqquestions` (
  `id` int(11) unsigned NOT NULL,
  `ask_username` varchar(100) NOT NULL,
  `ask_usermail` varchar(100) NOT NULL,
  `ask_rubrik` varchar(100) NOT NULL,
  `ask_content` text NOT NULL,
  `ask_date` varchar(20) NOT NULL,
  `is_visible` char(1) default 'Y',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqquestions`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqright`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqright` (
  `right_id` int(11) unsigned NOT NULL,
  `name` varchar(50) default NULL,
  `description` text,
  `for_users` int(1) default '1',
  `for_groups` int(1) default '1',
  PRIMARY KEY  (`right_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


-- 
-- โครงสร้างตาราง `faqweb_faqsessions`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqsessions` (
  `sid` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `ip` text NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY  (`sid`),
  KEY `idx_user_time` (`user_id`,`time`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqsessions`
-- 

REPLACE INTO `faqweb_faqsessions` (`sid`, `user_id`, `ip`, `time`) VALUES (1, -1, '192.168.1.252', 1217582650);

-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqtags`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqtags` (
  `tagging_id` int(11) NOT NULL,
  `tagging_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`tagging_id`,`tagging_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqtags`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faquser`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faquser` (
  `user_id` int(11) NOT NULL,
  `login` varchar(25) NOT NULL,
  `session_id` varchar(150) default NULL,
  `session_timestamp` int(11) unsigned default NULL,
  `ip` varchar(15) default NULL,
  `account_status` varchar(50) default NULL,
  `last_login` varchar(14) default NULL,
  `auth_source` varchar(100) default NULL,
  `member_since` varchar(14) default NULL,
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `login` (`login`),
  UNIQUE KEY `session` (`session_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faquser`
-- 

REPLACE INTO `faqweb_faquser` (`user_id`, `login`, `session_id`, `session_timestamp`, `ip`, `account_status`, `last_login`, `auth_source`, `member_since`) VALUES (1, 'admin', NULL, 1217582610, NULL, 'protected', NULL, NULL, '20080801162330'),
(-1, 'anonymous', NULL, 1217582610, NULL, 'protected', NULL, NULL, '20080801162330');

-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faquser_group`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faquser_group` (
  `user_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  PRIMARY KEY  (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faquser_group`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faquser_right`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faquser_right` (
  `user_id` int(11) NOT NULL,
  `right_id` int(11) NOT NULL,
  PRIMARY KEY  (`user_id`,`right_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faquserdata`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faquserdata` (
  `user_id` int(11) NOT NULL,
  `last_modified` timestamp NULL default NULL,
  `display_name` varchar(50) default NULL,
  `email` varchar(100) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faquserdata`
-- 

REPLACE INTO `faqweb_faquserdata` (`user_id`, `last_modified`, `display_name`, `email`) VALUES (1, '2008-08-01 16:23:30', 'admin', 'siwakorn@webexperts.co.th'),
(-1, '2008-08-01 16:23:30', 'Anonymous User', '');

-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faquserlogin`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faquserlogin` (
  `login` varchar(25) NOT NULL,
  `pass` varchar(150) default NULL,
  PRIMARY KEY  (`login`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faquserlogin`
-- 

REPLACE INTO `faqweb_faquserlogin` (`login`, `pass`) VALUES ('admin', 'e10adc3949ba59abbe56e057f20f883e'),
('anonymous', '3019fa5158e07873aa83a87caa0503a9');

-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqvisits`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqvisits` (
  `id` int(11) NOT NULL,
  `lang` varchar(5) NOT NULL,
  `visits` int(11) NOT NULL,
  `last_visit` int(15) NOT NULL,
  PRIMARY KEY  (`id`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqvisits`
-- 


-- --------------------------------------------------------

-- 
-- โครงสร้างตาราง `faqweb_faqvoting`
-- 

CREATE TABLE IF NOT EXISTS `faqweb_faqvoting` (
  `id` int(11) unsigned NOT NULL,
  `artikel` int(11) unsigned NOT NULL,
  `vote` int(11) unsigned NOT NULL,
  `usr` int(11) unsigned NOT NULL,
  `datum` varchar(20) NOT NULL default '',
  `ip` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- 
-- dump ตาราง `faqweb_faqvoting`
-- 