<?php

// TODO: ยังขาดการเรียกใช้ AuthenticateUser Observer จาก modules User ปัญหาคือยังไม่ทราบรหัสผ่านใน Observer AuthenticateUser ได้

class AuthWeb extends SGL_Observer
{
    
    function update($observable)
    {        
        $dbh = & SGL_DB::singleton();
        $c = &SGL_Config::singleton();
        $conf = $c->getAll();   

        // ตรวจสอบว่า module smfweb ถูกติดตั้งแล้วหรือยัง?
        require_once SGL_MOD_DIR  . '/main/classes/Main.php';
        $oMain = new Main;
        if ($oMain->verifyModules('authweb') === false) {
            return;
        }

        if (!$conf['RegisterMgr']['allowAuthWeb']) {
            return;
        }

        $req = &SGL_Request::singleton();
        $input = $req->getAll();
        $sglManager = $req->getManagerName();

       // เริ่มต้นการทำงานของ Observer
        require_once(SGL_MOD_DIR . '/authweb/classes/Api.php');        

        if ($sglManager == 'register') {
            if ($observable->input->action == 'insert') {
                $hashKey = insertHash($observable->input);
                $bEmailSent = sendActivateEmail($observable->oUser, $observable->input->moduleName, $conf, $hashKey);
                if (!$bEmailSent) {
                    return SGL::raiseError('Problem sending email', SGL_ERROR_EMAILFAILURE);
                }
                
            }
        } elseif ($sglManager == 'login') {
            if ($observable->input->action == 'login') {
                // Role 1 = Super Users :: Remove Expire Hash
                if (SGL_Session::getRoleId() == 1) { 
                    $ok = deleteExpireHash($observable->input);
                }
                // Check Account Status
                $isActivate = checkHash($observable->input->username);
                
                if ($isActivate === false) {
                    // force logout and destroy session
                    $uid = SGL_Session::getUid();
                    list(, $cookieValue) = @unserialize($_COOKIE['SGL_REMEMBER_ME']);
                    if (!empty($cookieValue)) {
                        require_once SGL_MOD_DIR . '/user/classes/UserDAO.php';
                        $da = &UserDAO::singleton();
                        $da->deleteUserLoginCookieByUserId($uid, $cookieValue);
                    }
                    
                    SGL_Session::destroy();
                    SGL::raiseMsg('Account is not activated.', true, SGL_MESSAGE_INFO);
                    $aParams['moduleName'] = 'user';
                    $aParams['managerName'] = 'login';
                    SGL_HTTP::redirect($aParams);

                }
                
            } 
        } elseif ($sglManager == 'user') {
            if ($observable->input->action == 'changeUserStatus') {
                $ok = removeHash($observable->input->userID);
            }
        }



    }
}
?>